	@  GCC AS
	.syntax unified
	.section .text

.macro	MOV32 regnum,number
	MOVW \regnum,:lower16:\number
	MOVT \regnum,:upper16:\number
.endm
.macro	MOVLo regnum,number
	MOVW \regnum,\number
.endm
.macro	MOVUp regnum,number
	MOVT \regnum,\number
.endm
.macro	CALL address
	BL \address
.endm
.macro	RET
	BX LR
.endm
.macro	JMP address
	B \address
.endm

.equ RCC_AHB1ENR, 0x40023830
.equ GPIOD_MODER, 0x40020C00
.equ GPIOD_ODR, 0x40020C14
.equ GPIODEN_BB, (RCC_AHB1ENR & 0x00FFFFFF) * 0x20 + 0x42000000 + 3 * 4


	@    
	@    ,
	@      
	.word	0x2001BFFF	@  ,    
	.word	Start+1	@  

Start:

	@   PORTD  
	@     BitBand
	MOV32 R0, GPIODEN_BB
	MOV R1, 1
	STR R1, [R0]

	@  12,13,14,15  
	MOV32 R0, GPIOD_MODER
	MOV32 R1, 0x55000000
	STR R1, [R0]

	MOV R1, 0			@  
	MOV32 R2, GPIOD_ODR	@   

:

	MOVLo R1, 0xA000		@  
	STR R1, [R2]

	CALL 

	MOVLo R1, 0x5000		@  
	STR R1, [R2]

	CALL 

	JMP 


:
	@  1    16 
	MOVUp R0, 0x004C
	1:
	SUBS R0, R0, 1
	BNE 1
	RET

.end
